(* register.sml *)

signature REGISTER =
sig 
  include REGISTER_STD

  val EDX : Temp.temp
  val ESI : Temp.temp
  val EDI : Temp.temp

  val truecallersaves : register list (* CodeGen use only! *)

  val NPSEUDOREGS : int  (* CodeGen use only! *)

end (* signature REGISTER *)


structure Register : REGISTER = 
struct

  type register = string

  val RV = Temp.newtemp()
  val FP = Temp.newtemp()

  val SP = Temp.newtemp()

  val EDX = Temp.newtemp()
  val ESI = Temp.newtemp()
  val EDI = Temp.newtemp()

  (* of course, none of the following should be empty list *)

  val NPSEUDOREGS = 32 
  val localsBaseOffset : int = ~4*NPSEUDOREGS (* locals start after pseudoregisters *)
  val paramBaseOffset : int = 8               (* params start before return address + stored frame pointer *)

  val specialregs : (Temp.temp * register) list = []
  val argregs : (Temp.temp * register) list = []
  val calleesaves : register list = []
  val truecallersaves : register list = []
  val callersaves : register list = ["%esi", "%edi", "%ebx", "%ecx", "%edx", "%eax"]

end (* structure Register *)

